commit 283b97965ffbb78323e9b4e962eaf8e2c338c7c5
Author: David Faust <david.faust@oracle.com>
Date:   Tue Sep 22 20:31:35 2020 +0200

    bpf: use xBPF signed div, mod insns when available
    
    The 'mod' and 'div' operators in eBPF are unsigned, with no signed
    counterpart. xBPF adds two new ALU operations, sdiv and smod, for
    signed division and modulus, respectively. Update bpf.md with
    'define_insn' blocks for signed div and mod to use them when targetting
    xBPF, and add new tests to ensure they are used appropriately.
    
    2020-09-17  David Faust  <david.faust@oracle.com>
    
    gcc/
            * config/bpf/bpf.md: Add defines for signed div and mod operators.
    
    gcc/testsuite/
            * gcc.target/bpf/diag-sdiv.c: New test.
            * gcc.target/bpf/diag-smod.c: New test.
            * gcc.target/bpf/xbpf-sdiv-1.c: New test.
            * gcc.target/bpf/xbpf-smod-1.c: New test.
    
    (cherry picked from commit 7c8ba5da80d5d95a8521010d6731d0d83036145d)

diff --git a/gcc/testsuite/gcc.target/bpf/diag-sdiv.c b/gcc/testsuite/gcc.target/bpf/diag-sdiv.c
new file mode 100644
index 00000000000..db0c494a789
--- /dev/null
+++ b/gcc/testsuite/gcc.target/bpf/diag-sdiv.c
@@ -0,0 +1,12 @@
+/* Verify signed division does not produce 'sdiv' insn in eBPF.  */
+/* { dg-do compile } */
+/* { dg-options "-O0" } */
+
+void
+foo ()
+{
+  signed int x = 5;
+  signed int y = 2;
+  signed int z = x / y;
+}
+/* { dg-final { scan-assembler-not "sdiv(32)?\t%r" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/diag-smod.c b/gcc/testsuite/gcc.target/bpf/diag-smod.c
new file mode 100644
index 00000000000..20234ee39cc
--- /dev/null
+++ b/gcc/testsuite/gcc.target/bpf/diag-smod.c
@@ -0,0 +1,12 @@
+/* Verify signed modulo does not produce 'smod' insn in eBPF.  */
+/* { dg-do compile } */
+/* { dg-options "-O0" } */
+
+void
+foo ()
+{
+  signed int x = 5;
+  signed int y = 2;
+  signed int z = x % y;
+}
+/* { dg-final { scan-assembler-not "smod(32)?\t%r" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/xbpf-sdiv-1.c b/gcc/testsuite/gcc.target/bpf/xbpf-sdiv-1.c
new file mode 100644
index 00000000000..f6c5c9e9f1c
--- /dev/null
+++ b/gcc/testsuite/gcc.target/bpf/xbpf-sdiv-1.c
@@ -0,0 +1,14 @@
+/* Verify that sdiv instruction is used for xBPF. */
+/* { dg-do compile } */
+/* { dg-options "-O0 -mxbpf" } */
+
+void
+foo ()
+{
+  signed int x = 5;
+  signed int y = 2;
+  signed int z = x / y;
+  signed int w = x / 3;
+}
+
+/* { dg-final { scan-assembler "sdiv(32)?\t%r" } } */
diff --git a/gcc/testsuite/gcc.target/bpf/xbpf-smod-1.c b/gcc/testsuite/gcc.target/bpf/xbpf-smod-1.c
new file mode 100644
index 00000000000..b3e5816b5cf
--- /dev/null
+++ b/gcc/testsuite/gcc.target/bpf/xbpf-smod-1.c
@@ -0,0 +1,14 @@
+/* Verify that smod instruction is used for xBPF. */
+/* { dg-do compile } */
+/* { dg-options "-O0 -mxbpf" } */
+
+void
+foo ()
+{
+  signed int x = 5;
+  signed int y = 2;
+  signed int z = x % y;
+  signed int w = x % 3;
+}
+
+/* { dg-final { scan-assembler "smod(32)?\t%r" } } */

